Program damier;
uses Graph,Crt,Dos;

const
  Gray50 : FillPatternType = ($FF, $FF, $FF,
    $FF, $FF, $FF, $FF, $FF);
  Gray20 : FillPatternType = ($AA, $55, $AA,
    $55, $AA, $55, $AA, $55);
Type
     tab   = record pion:integer;
                    chd : integer;
                    chg : integer;
                    cd : integer;
                    cg : integer;
                    cbd : integer;
                    cbg : integer;
                    x:integer;
                    y:integer;
              end;
     cas = array [1..121] of tab;
     jeu = array[1..6] of integer;
     act = array [1..6] of boolean;
     nomj = array [1..6] of string [20];

Var
  fich:text;
  Size : Word;
  cases:cas;
  touche,touchebis:char;
  prec,joueur : integer;
  ancienne,active,sauve,premier:integer;
  fin, echec,typ,correct, nouv : boolean;
  cle : integer;
  nomf,player:string;
  P:pointer;
  i,nb:integer;      {Nb de joueurs}
  cor : jeu;
  present : act;
  nom:nomj;
  phrase:string[20];
  r : registers;
  position_x, position_y, bouton : word;
  tps : integer;
  nbparam : byte;

Procedure boutton1;
Begin
  SetFillPattern(Gray50, 7);
  Bar(290, 340, 340, 355);
  SetFillPattern(Gray50, 7);
  SetColor (15);
  Line (290,340,290,355);   Line (290,340,340,340);
  SetColor (0);
  Line (340,340,340,355);   Line (290,355,340,355);
  OutTextXY (307,345,'OK');
End;

Function chainval (val:word):string;
Var
  borne,j,i:integer;
  inter : array [1..5] of integer;
  mot : string;

Begin
  For i := 1 to 5 do
    inter[i] := 0;
  i := 1;
  borne := 10000;
  For j := 1 to 5 do
  Begin
    If (val >= borne) then
    Begin
      inter[i] := val div borne;
      val := val - inter[i]*borne;
    End
    Else
      inter[i] := 0;
    borne := borne div 10;
    i := i+1;
  End;
  mot := '';
  i := 1;
  While ((inter[i] <> -1) and (i<=5)) do
  Begin
    mot := mot + chr(inter[i]+48);
    i := i+1;
  End;
  chainval := mot;
End;

Procedure Fenetre;
Begin
  SetFillPattern(Gray50, 3);
  Bar(180, 150, 450, 370);
  SetFillPattern(Gray20,1);
  Bar(180,150,450,155);
  Bar(180,150,185,370);
  Bar(445,150,450,370);
  Bar(180,365,450,370);
End;

Procedure Boutton2;
Begin
  SetFillPattern(Gray50, 7);
  Bar(230, 340, 300, 355);
  SetFillPattern(Gray50, 7);
  SetColor (15);
  Line (230,340,230,355);   Line (230,340,300,340);
  SetColor (0);
  Line (300,340,300,355);   Line (230,355,300,355);
  OutTextXY (257,345,'OK');
  SetFillPattern(Gray50, 7);
  Bar(330, 340, 400, 355);
  SetFillPattern(Gray50, 7);
  SetColor (15);
  Line (330,340,330,355);   Line (330,340,400,340);
  SetColor (0);
  Line (400,340,400,355);   Line (330,355,400,355);
  OutTextXY (340,345,'Annuler');
End;

Procedure init_mouse;
Var erreur: word;

Begin
      r.ax:= 0;
      intr($33, r);
      erreur:= r.ax;
End;

Procedure affiche_mouse;
    begin
      r.ax:= 1;
      intr($33, r);
End;

  procedure cache_mouse;
    begin
      r.ax:= 2;
      intr($33, r);
    end;

  procedure etat_mouse;
    begin
      r.ax:= 3;
      intr($33, r);
      position_x:= r.cx;
      position_y:= r.dx;
      bouton:= r.bx;
    end;

Procedure branche (Var nb:integer;
                   Var cor:jeu;
                   Var present:act);

Var
  i : integer;
Begin
  If (nb = 2) then
  Begin
    cor[1] := 1;
    cor[2] := 1;
    cor[3] := 1;
    cor[4] := 2;
    cor[5] := 2;
    cor[6] := 2;
  End;
  If (nb = 3) then
  Begin
    cor[1] := 1;
    cor[2] := 1;
    cor[3] := 2;
    cor[4] := 2;
    cor[5] := 3;
    cor[6] := 3;
  End;
  If (nb = 4) then
  Begin
    cor[1] := 1;
    cor[2] := -1;
    cor[3] := 2;
    cor[4] :=  3;
    cor[5] := -1;
    cor[6] := 4;
  End;
  If (nb = 6) then
  Begin
    cor[1] := 1;
    cor[2] := 2;
    cor[3] := 3;
    cor[4]:=  4;
    cor[5] := 5;
    cor[6] := 6;
  End;
  For i:= 1 to nb do
    present[i] := true;
  For i:=nb+1 to 6 do
    present[i] := false;
End;

Procedure ligne (btn : integer;
                 Var name : nomj;
                 Var posit : integer);
Var
  i : integer;
Begin
  posit := 1;
  cache_mouse;
  for i := 1 to 6 do
  begin
    setcolor (3);
    OutTextXY (300,210+i*10,name [i]);
    name [i] := '';
  end;
  for i := 0 to 3 do
  begin
    if btn = i  then Setcolor (0)
    else setcolor (15);
    Line (210 +i*60,200,240+i*60,200);   Line (210+i*60,200,210+i*60,210);
    SetColor (0);
    Line (210 +i*60,210,240+i*60,210);   Line (240+i*60,200,240+i*60,210);
  end;
  Setcolor (red);
  OutTextXY (190,220,'Joueur 1 : ');
  Setcolor (white);
  OutTextXY (190,230,'Joueur 2 : ');
  if btn < 1 then
  begin
    Setcolor (black);
    OutTextXY (190,240,'Joueur 3 :');
  end
  else
  begin
    Setcolor (white);
    OutTextXY (190,240,'Joueur 3 :');
  end;
  if btn < 2 then
  begin
    Setcolor (black);
    OutTextXY (190,250,'Joueur 4 :');
  end
  else
  begin
    Setcolor (white);
    OutTextXY (190,250,'Joueur 4 :');
  end;
  if btn < 3 then
  begin
    Setcolor (black);
    OutTextXY (190,260,'Joueur 5 :');
    OutTextXY (190,270,'Joueur 6 :');
  end
  else
  begin
    Setcolor (white);
    OutTextXY (190,260,'Joueur 5 :');
    OutTextXY (190,270,'Joueur 6 :');
  end;
  affiche_mouse;
end;

Procedure fleche (plus : boolean;
                  Var posit : integer;
                  name : nomj);
Begin
  cache_mouse;
  if plus then
  begin
    Setcolor (white);
    OutTextXY (190,210 + posit * 10,'Joueur ' + chr (posit + 48) + ' :');
    OutTextXY (300,210 + posit * 10,name[posit]);
    posit := posit - 1;
    Setcolor (red);
    OutTextXY (190,210 + posit * 10,'Joueur ' + chr (posit+48) + ' :');
    OutTextXY (300,210 + posit * 10,name[posit]);
  end
  else
  begin
    Setcolor (white);
    OutTextXY (190,210 + posit * 10,'Joueur ' + chr (posit+48) + ' :');
    OutTextXY (300,210 + posit * 10,name[posit]);
    posit := posit + 1;
    Setcolor (red);
    OutTextXY (190,210 + posit * 10,'Joueur ' + chr (posit+48) + ' :');
    OutTextXY (300,210 + posit * 10,name[posit]);
  end;
  affiche_mouse;
End;

Procedure option (Var cor:jeu;
                  Var nb : integer;
                  Var present:act;
                  Var nom:nomj);
Var
  car : char;
  carbis : char;
  i,j : integer;
  phrase : string;
  plantage : boolean;
  fin : boolean;
  posit : integer;
  chainbis : string;
  btn : integer;

Begin
  setcolor (15);
  Fenetre;
  Boutton1;
  SetColor (15);
  OutTextXY (190,165,'Les joueurs : ');
  SetFillPattern(Gray20, 1);
  Bar (180,180,450,175);
  SetFillPattern(Gray50, 7);
  Bar(210, 200, 240, 210);
  Bar(270, 200, 300, 210);
  Bar(330, 200, 360, 210);
  Bar(390, 200, 420, 210);
  btn := 0;
  nb := 2;
  fin := false;
  for i := 1 to 6 do
  begin
    nom [i] := '';
  end;
  ligne (0,nom,posit);
  Setcolor (0);
  OutTextXY (221 ,202,'2');
  OutTextXY (221 + 60 ,202,'3');
  OutTextXY (221 + 120 ,202,'4');
  OutTextXY (221 + 180 ,202,'6');
  affiche_mouse;
  Repeat
        if keypressed then
        begin
          car := readkey;
          if (ord (car) = 0) and (keypressed) then
          begin
            carbis := readkey;
            if (ord (carbis) = 72)  and (posit > 1) then
              fleche (true, posit, nom);
            if ord (carbis) = 80 then
            begin
              if (btn = 0) and (posit = 1) then fleche (false, posit, nom)
              else
              if (btn = 1) and (posit < 3) then fleche (false, posit, nom)
              else
              if (btn = 2) and (posit < 4) then fleche (false, posit, nom)
              else
              if (btn = 3) and (posit < 6) then fleche (false, posit, nom);
            end;

          end
          else
          begin
            chainbis :='';
            SetColor (3);
            OutTextXY (300,210 + posit * 10,nom [posit]);
            if ord (car) = 8 then
            begin
              for i := 1 to (Length (nom[posit]) - 1) do
                chainbis  := chainbis + nom [posit] [i];
              nom [posit] := chainbis;
            end
            else nom [posit] := nom [posit] + car;
            SetColor (red);
            OutTextXY (300,210 + posit * 10,nom [posit]);
          end;
        end;

      etat_mouse;
      if (bouton = 1) then
      begin
      if (position_x <= 240) and (position_x >= 210) and (position_y <= 210) and (position_y >= 200) then
      if btn <> 0 then
      begin
        btn := 0;
        nb := 2;
        ligne (0,nom,posit);
      end;
      if (position_x <= 300) and (position_x >= 270) and (position_y <= 270) and (position_y >= 200) then
        if btn <> 1 then
        begin
          btn := 1;
          nb := 3;
          ligne (1,nom,posit);
        end;
      if (position_x <= 360) and (position_x >= 330) and (position_y <= 330) and (position_y >= 200) then
        if btn <> 2 then
        begin
          btn := 2;
          nb := 4;
          ligne (2,nom,posit);
        end;
      if (position_x <= 420) and (position_x >= 390) and (position_y <= 390) and (position_y >= 200) then
        if btn <> 3 then
        begin
          btn := 3;
          nb := 6;
          ligne (3,nom,posit);
        end;

    if (position_x >=290) and (position_x <=340) and (position_y >=340) and (position_y <=355) then
      fin := true;
   end;
  Until fin;

  cache_mouse;
  Fenetre;
  boutton1;
  SetColor (15);
  OutTextXY (190,165,'Les joueurs : ');
  SetFillPattern(Gray20, 1);
  Bar (180,180,450,175);
  branche (nb,cor,present);
  For i := 1 to 6 do
  Begin
    phrase := 'Branche '+ chr (i+48);
    If (cor[i] = -1) then
      phrase := phrase + 'inactive'
    Else
      phrase := phrase + ' affect  '+nom[cor[i]];
    OutTextXY (195,200+15*i, phrase);
  End;
  affiche_mouse;
  Repeat
    etat_mouse;
  Until (bouton = 1) and (position_x >=290) and (position_x <=340) and (position_y >=340) and (position_y <=355);
  cache_mouse;
End;


Procedure sauvegarde (cases:cas;
                      nomf : string;
                      joueur : integer;
                      cle : integer;
                      nb:integer;
                      present:act;
                      premier:integer;
                      nom:nomj);

Var
  i:integer;
  fich:text;
  n:integer;


Begin
  {Initialisation}
  Assign (fich,nomf);
  Rewrite (fich);
  Writeln (fich,'*Ne pas modifier*');
  Writeln (fich,joueur); {joueur ayant la main}
  Writeln (fich,nb); {nb de joueurs}
  For i:= 1 to nb do
    Writeln (fich,nom[i]);
  Writeln (fich,cle); {Situation}
  {Si joueurs inactifs}
  n := 0;
  For i:= 1 to 6 do
    If (present[i] = false) then
      n := n+1;
  Write (fich,n,' '); {Nombre de joueurs inactifs}
  For i:= 1 to 6 do
    If (present[i] = false) then
      Write (fich,i,' ');
  Writeln (fich,'');
  Writeln (fich, premier); {Le vainqueur}
  For i:= 1 to 121 do
  Begin
    Write (fich,cases[i].x);
    Write (fich,' ');
    Write (fich,cases[i].y);
    Write (fich,' ');
    Write (fich,cases[i].chd);
    Write (fich,' ');
    Write (fich,cases[i].chg);
    Write (fich,' ');
    Write (fich,cases[i].cd);
    Write (fich,' ');
    Write (fich,cases[i].cg);
    Write (fich,' ');
    Write (fich,cases[i].cbd);
    Write (fich,' ');
    Write (fich,cases[i].cbg);
    Write (fich,' ');
    Writeln (fich,cases[i].pion);
  End;
  {Initialisation des cases}
  Close (fich);
End;

Procedure grille (Var cases:cas;
                  nomf : string;
                  Var joueur : integer;
                  Var cle:integer;
                  Var nb:integer;
                  Var present:act;
                  Var premier:integer;
                  Var cor:jeu;
                  nouv:boolean;
                  Var nom:nomj);

var
 i,pivot,chif:integer;
 fich:text;
 phrase:string;

Begin
  Assign (fich,nomf);
  Reset (fich);
  SetColor (15);
  Readln (fich,phrase);
  If (phrase <> '*Ne pas modifier*') then
  begin
    closegraph;
    Halt (1);
  end;
  Readln (fich,chif);
  joueur := chif;
  Readln (fich,chif);
  nb := chif;
  For i:= 1 to nb do
    Readln (fich,nom[i]);
  If (not(nouv)) Then
    branche (nb,cor,present)
  Else
    option (cor,nb,present,nom);
  ClearDevice;
  Readln (fich,chif);
  cle := chif;
  Read (fich,pivot);
  For i:= 1 to pivot do
  Begin
    Read (fich,chif);
    present[chif] := false;
  End;
  Readln (fich,phrase);
  Readln (fich,chif);
  premier:=chif;
  For i:= 1 to 121 do
  Begin
    Read (fich,chif);
    cases[i].x := chif;
    Read (fich,chif);
    cases[i].y := chif;
    Read (fich,chif);
    cases[i].chd := chif;
    Read (fich,chif);
    cases[i].chg := chif;
    Read (fich,chif);
    cases[i].cd := chif;
    Read (fich,chif);
    cases[i].cg := chif;
    Read (fich,chif);
    cases[i].cbd := chif;
    Read (fich,chif);
    cases[i].cbg := chif;
    Readln (fich,chif);
    cases[i].pion := chif;
    Circle (cases[i].x+7,cases[i].y+8,13);
  End;
  {Initialisation des cases}
  Close (fich);
End;

Procedure init;
Var
  Gd,Gm : Integer;
Begin
  Gd := Detect;
  InitGraph(Gd, Gm, ' ');
  If GraphResult <> grOk then
  begin
    closegraph;
    Halt(1);
  end;
End;

Procedure Menu;

Var
  Touche:char;
begin
  SetFillPattern(Gray50, 7);
  Bar(7, 6, 135, 17);
  Bar(7, 21, 135, 32);
  Bar(7, 36, 135, 47);
  Bar(7, 51, 135, 62);
  Bar(7, 66, 135, 77);
  Bar(7, 81, 135, 92);
  SetColor (15);
  Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
  Line (5,20,5,32);  Line (6,20,6,32);  Line (5,20,135,20);
  Line (5,35,5,47);  Line (6,35,6,47);  Line (5,35,135,35);
  Line (5,50,5,62);  Line (6,50,6,62);  Line (5,50,135,50);
  Line (5,65,5,77);  Line (6,65,6,77);  Line (5,65,135,65);
  Line (5,80,5,92);  Line (6,80,6,92);  Line (5,80,135,80);
  SetColor (0);
  OutTextXY (10,8,'Nouvelle partie');
  OutTextXY (10,23,'Sauvegarder');
  OutTextXY (10,38,'Charger');
  OutTextXY (10,53,'Annuler');
  OutTextXY (10,68,'?');
  OutTextXY (10,83,'Quitter');
End;

Procedure Affichage (cases:cas);
Var i:integer;

Begin
  For i:= 1 to 121 do
  Begin
    If (cases[i].pion > 0) then
    Begin
      SetFillPattern(Gray50,cases[i].pion);
      Bar (cases[i].x,cases[i].y,cases[i].x + 14,cases[i].y+14);
    End
    Else
    Begin
      SetFillPattern(Gray50,black);
      Bar (cases[i].x,cases[i].y,cases[i].x + 14,cases[i].y+14);
    End;
  End;
End;

Procedure echange (cases:cas;
                   first:integer;
                   second:integer);

Begin
    If (cases[first].pion > 0) then
    Begin
      SetFillPattern(Gray50,cases[first].pion);
      Bar (cases[first].x,cases[first].y,cases[first].x + 14,cases[first].y+14);
    End
    Else
    Begin
      SetFillPattern(Gray50,black);
      Bar (cases[first].x,cases[first].y,cases[first].x + 14,cases[first].y+14);
    End;
    If (cases[second].pion > 0) then
    Begin
      SetFillPattern(Gray50,cases[second].pion);
      Bar (cases[second].x,cases[second].y,cases[second].x + 14,cases[second].y+14);
    End
    Else
    Begin
      SetFillPattern(Gray50,black);
      Bar (cases[second].x,cases[second].y,cases[second].x + 14,cases[second].y+14);
    End;
End;

Procedure inversion (Var active:integer;
                     nouvelle:integer;
                     cases : cas);

Begin
  SetColor (15);
  Circle ((cases[active].x)+7,(cases[active].y)+8,13);
  SetColor (5);
  Circle ((cases[nouvelle].x)+7,(cases[nouvelle].y)+8,13);
  active:=nouvelle;
End;

Function test (cases : cas;
               sauve : integer;
               active : integer;
               cle : integer;
               joueur : integer):boolean;

Var
  max,min,nb,coox : integer;
  indicateur : boolean;
  fich:text;

Begin
  indicateur := false;
  If (cle=2) then
  Begin
    If ((cases[active].cbd = sauve) or (cases[active].cbg = sauve)) then
      indicateur := true
    Else
      If ((cases[active].chd = sauve) or (cases[active].chg = sauve)) then
        indicateur := true
      Else
        If ((cases[active].cg = sauve) or (cases[active].cd = sauve)) then
          indicateur := true;
  End;

  If (not (indicateur)) then
  Begin
    If (cases[active].x < cases[sauve].x) then
    Begin
      max := sauve;
      min := active;
    End
    Else
    Begin
      max := active;
      min := sauve;
    End;
    {Deplacement horizontal}
    If (((cases[max].x - cases[min].x) mod 100 = 0) and (cases[max].y - cases[min].y = 0)) then
    Begin
      nb := 0;
      While ((min <> cases[max].cg) and (nb<2)) do
      Begin
        min := cases[min].cd;
        If (cases[min].pion <> -1) then
        Begin
          nb := nb+1;
          coox := cases[min].x
        End;
      End;
      If ((nb=1) and (coox = (cases[sauve].x +cases[active].x )/2 )) then
        indicateur := true;
    End
    Else
    If (((cases[max].y - cases[min].y) mod 56 = 0) and ((cases[max].x - cases[min].x) mod 50 = 0)) then
    Begin
      If (((cases[max].y - cases[min].y) * (50) div 56) = (cases[max].x - cases[min].x)) then
      Begin
        nb := 0;
        While ((min <> cases[max].chg) and (nb<2)) do
        Begin
          min := cases[min].cbd;
          If (cases[min].pion <> -1) then
          Begin
            nb := nb+1;
            coox := cases[min].x
          End;
        End;
        If ((nb=1) and (coox = (cases[sauve].x +cases[active].x )/2 )) then
          indicateur := true;
      End
      Else
      If ((cases[max].y - cases[min].y) * (-50) div 56 = cases[max].x - cases[min].x) then
      Begin
        nb := 0;
        While ((min <> cases[max].cbg) and (nb<2)) do
        Begin
          min := cases[min].chd;
          If (cases[min].pion <> -1) then
          Begin
            nb := nb+1;
            coox := cases[min].x
          End;
        End;
        If ((nb=1) and (coox = (cases[sauve].x +cases[active].x )/2 )) then
          indicateur := true;
      End;
    End;
  End;
  test := indicateur;
End;


Procedure Vincent;
Begin
  Fenetre;
  SetColor (15);
  OutTextXY (190,160,'?');
  Bar (180,170,450,175);
  OutTextXY (190,180,'Les Dames Chinoises');
  OutTextXY (190,190,'Version souris ');
  OutTextXY (200,200,'2,3,4 ou 6 joueurs');
  OutTextXY (190,220,'Ecrit par Vincent Raynal');
  OutTextXY (190,230,'En Turbo Pascal 7.0');
  OutTextXY (190,240,'Annee : 1998');
  OutTextXY (190,260,'e-mail : naugrim@hotmail.com');
  OutTextXY (190,280,'Les commandes : ');
  OutTextXY (190,300,'clic gauche : Slectionner');
  OutTextXY (190,310,'clic droit  : Intermdiaire ');
  boutton1;
  affiche_mouse;
  Repeat
    etat_mouse;
  Until (bouton = 1) and (position_x >=290) and (position_x <=340) and (position_y >=340) and (position_y <=355);
  cache_mouse;
End;


Procedure demande (Var chain:string;
                   typ : boolean;
                   Var echec : boolean);


Var
  correct : boolean;
  tmp : char;
  chainbis : string;
  i,Y : integer;
Begin
  Fenetre;
  Boutton2;
  SetColor (15);
  OutTextXY (190,160,'Entrez votre nom de fichier');
  OutTextXY (200,170,'avec l''extension .IND ...');
  SetFillPattern(Gray20,1);
  Bar(180,180,450,185);
  correct := false;
  echec := false;
  affiche_mouse;
  Repeat
    chain := '';
      Repeat
        if keypressed then
        begin
          chainbis :='';
          tmp := UpCase (readkey);
          SetColor (3);
          OutTextXY (200,200,chain);
          if ord (tmp) = 8 then
          begin
            for i := 1 to (Length (chain) - 1) do
              chainbis  := chainbis + chain [i];
            chain := chainbis;
          end
          else chain := chain + tmp;
          SetColor (15);
          OutTextXY (200,200,chain);
        end;
        etat_mouse;
      Until (bouton = 1) and (position_y >= 340) and (position_y <= 355) and (((position_x <= 300) and (position_x >=230))
        or ((position_x <= 400) and (position_x >=330)));
      if chain = '' then chain := 'A';
      For i := 1 to Length(chain) do
        chain[i] := UpCase(chain[i]);
      if position_x >= 330 then
      begin
        correct := true;
        echec := true;
      end
      Else
      If (chain = 'DAMESS2.IND') then
      Begin
        SetColor (3);
        OutTextXY (190,330,'Ce fichier n existe pas');
        OutTextXY (200,200,chain);
        SetColor (15);
        OutTextXY (190,330,'Fichier rserv');
      End
      Else
        Begin
          If (FSearch (chain,'C:') <> chain) then
          Begin
            If (typ) then
            Begin
              SetColor (3);
              OutTextXY (190,330,'Fichier rserv');
              OutTextXY (200,200,chain);
              SetColor (15);
              OutTextXY (190,330,'Ce fichier n existe pas');
            End
            Else
              correct := true;
          End
          Else
            correct := true;
          End;
  Until (correct);
End;

Procedure recherche (var numcase:integer);
Var
  xr,yr : word;
  i : integer;
  trouve : boolean;

Begin
  trouve := false;
  etat_mouse;
  xr := position_x;
  yr := position_y;
  numcase := 0;
  i := 1;
  repeat
    if (xr >= cases [i].x - 1) and (xr <= cases [i].x + 15) and (yr >= cases [i].y - 1) and (yr <= cases [i].y + 15) then
    begin
      trouve := true;
      numcase := i;
    end;
    i := i + 1;
  until (i > 121) or (trouve);
End;

Procedure deplacement (Var cases:cas;
                       Var active:integer;
                       Var joueur : integer;
                       Var prec : integer;
                       Var cle : integer;
                       Var sauve : integer;
                       P:pointer;
                       Size:Word;
                       Var ancienne:integer;
                       Var cor:jeu;
                       Var nb:integer;
                       Var premier:integer;
                       Var nom:nomj);

Var
  correct : boolean;
  touche,touchebis : char;
  val:integer;
  numcase:integer;
Begin
  correct := false;
  Repeat
    delay (round (tps * 3 / 5));
    Repeat
      bouton := 0;
      etat_mouse;
    Until bouton > 0;
    if (position_x >= 5) and (position_x <= 135) and (position_y <= 92) then
    begin
      if (position_y <= 17) and (position_y >= 5 ) then
      begin
                correct := true;
                ancienne := -1;
                nomf := 'damess2.ind';
                cache_mouse;
                SetColor (0);
                Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
                Size := ImageSize(180, 150, 450, 370);
                GetMem(P, Size);   { Allocate memory on heap }
                GetImage(180, 150, 450, 370, P^);
                SetColor (0);
                OutTextXY (400,25,nom[joueur]);
                grille (cases,nomf,joueur,cle,nb,present,premier,cor,true,nom);
                Menu;
                SetColor (15);
                OutTextXY (400,25,nom[joueur]);
                PutImage(180, 150, P^, NormalPut);
                FreeMem (P,Size);
                SetColor (0);
                Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
                SetColor (15);
                Circle ((cases[active].x)+7,(cases[active].y)+8,13);
                active :=1;
                affichage (cases);
                SetColor (15);
                Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
                affiche_mouse;
      end;
      if (position_y <= 32) and (position_y >= 20 ) then
      begin
        If (cle=1) then
        Begin
          cache_mouse;
          SetColor (0);
          Line (5,20,5,32);  Line (6,20,6,32);  Line (5,20,135,20);
          Size := ImageSize(180, 150, 450, 370);
          GetMem(P, Size);   { Allocate memory on heap }
          GetImage(180, 150, 450, 370, P^);
          typ := false;
          Demande (nomf,typ,echec);
          cache_mouse;
          PutImage(180, 150, P^, NormalPut);
          FreeMem (P,Size);
          if not echec then Sauvegarde (cases,nomf,joueur,cle,nb,present,premier,nom);
          SetColor (15);
          Line (5,20,5,32);  Line (6,20,6,32);  Line (5,20,135,20);
          delay (tps);
          affiche_mouse;
        End;
      end;
      if (position_y <= 47) and (position_y >= 35 ) then
      begin
                 cache_mouse;
                 SetColor (0);
                 Line (5,35,5,47);  Line (6,35,6,47);  Line (5,35,135,35);
                 Size := ImageSize(180, 150, 450, 370);
                 GetMem(P, Size);   { Allocate memory on heap }
                 GetImage(180, 150, 450, 370, P^);
                 typ := true;
                 Demande (nomf,typ,echec);
                 cache_mouse;
                 PutImage(180, 150, P^, NormalPut);
                 FreeMem (P,Size);
                 If (not (echec)) then
                 Begin
                   ancienne := -1;
                   correct := true;
                   SetColor (0);
                   OutTextXY (400,25,nom[joueur]);
                   grille (cases,nomf,joueur,cle,nb,present,premier,cor,false,nom);
                   SetColor (15);
                   Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
                   Menu;
                   SetColor (15);
                   OutTextXY (400,25,nom[joueur]);
                   active := 1;
                   affichage (cases);
                 End;
                 SetColor (15);
                 Line (5,35,5,47);  Line (6,35,6,47);  Line (5,35,135,35);
                 delay (tps);
                 affiche_mouse;
      end;
      if (position_y <= 62) and (position_y >= 50 ) then
      begin
        cache_mouse;
          If ((cle=1) and (ancienne > 0)) then
          Begin
            cle := 1;
            SetColor (0);
            OutTextXY (400,25,nom[joueur]);
            joueur := prec;
            SetColor (15);
            OutTextXY (400,25,nom[joueur]);
            cases[ancienne].pion := cases[sauve].pion;
            If (ancienne <> sauve) then
              cases[sauve].pion := -1;
            ancienne := -1;
            Affichage (cases);
          End
          Else
          If (cle = 3) then
          Begin
            cle := 1;
            cases[ancienne].pion := cases[sauve].pion;
            If (ancienne <> sauve) then
              cases[sauve].pion := -1;
            SetColor (0);
            Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
            ancienne := -1;
            Affichage (cases);
          End;
        affiche_mouse;
      end;
      if (position_y <= 77) and (position_y >= 65 ) then
      begin
                 cache_mouse;
                 Size := ImageSize(180, 150, 450, 370);
                 GetMem(P, Size);   { Allocate memory on heap }
                 GetImage(180, 150, 450, 370, P^);
                 SetColor (0);
                 Line (5,65,5,77);  Line (6,65,6,77);  Line (5,65,135,65);
                 Vincent;
                 SetColor (15);
                 Line (5,65,5,77);  Line (6,65,6,77);  Line (5,65,135,65);
                 PutImage(180, 150, P^, NormalPut);
                 FreeMem (P,Size);
                 affiche_mouse;
      end;
      if (position_y <= 92) and (position_y >= 80 ) then
      begin
                 closegraph;
                 Halt (1);
      end;
    end
    else
    begin
      recherche (numcase);
      if numcase > 0 then
      begin
        active := numcase;
        cache_mouse;
        if bouton = 1 then
        begin
          If (cle = 2) then
          Begin
            cache_mouse;
            SetColor (0);
            Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
            If ((cases[active].pion = -1) and test (cases,sauve,active,cle,joueur)) then
            Begin
              correct := true;
              cle := 0;
              cases[active].pion := cases[sauve].pion;
              cases[sauve].pion := -1;
              echange (cases,sauve,active);
              sauve := active;
            End
            Else
              cle := 1;
            affiche_mouse;
          End
          Else
            If ((cle = 1) and (cases[active].pion <> -1) and (cor[cases[active].pion] = joueur)) then
            Begin
              correct := true;
              ancienne := active;
              sauve := active;
              cle := 2;
              SetColor (4);
              Circle ((cases[active].x)+7,(cases[active].y)+8,18);
            End
            Else
            If (cle = 3) then
            Begin
              If (active=sauve) then
              Begin
                SetColor (0);
                Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
                correct := true;
                cle := 0;
              End
              Else
                If ((test(cases,sauve,active,cle,joueur)) and (cases[active].pion = -1)) then
                Begin
                  correct := true;
                  cle :=0;
                  cases[active].pion := cases[sauve].pion;
                  cases[sauve].pion := -1;
                  cache_mouse;
                  affichage (cases);
                  SetColor (0);
                  Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
                  affiche_mouse;
                  sauve := active
                End;
            End;
        end;
        if bouton = 2 then
        begin
          If ((cle>1) and (cases[active].pion = -1) and (active <> sauve)) then
          Begin
            val := cle;
            cle := 3;
            If (test (cases,sauve,active,cle,joueur)) then
            Begin
              val := cle;
              correct := true;
              cache_mouse;
              cases[active].pion := cases[sauve].pion;
              cases[sauve].pion := -1;
              SetColor (0);
              Circle ((cases[sauve].x)+7,(cases[sauve].y)+8,18);
              SetColor (4);
              Circle ((cases[active].x)+7,(cases[active].y)+8,18);
              echange (cases,active,sauve);
              affiche_mouse;
              sauve := active;
            End
            Else
              cle := val;
          End;
        end;
(*        init_mouse; *)
        affiche_mouse;
      end;
    end;
  Until correct
End;

Function Victoire (cases :cas;
                   cor:jeu;
                   Var present:act;
                   joueur:integer;
                   Var premier:integer):boolean;

Var
  j,i,col,point : integer;
  rangee : array [1..6] of integer;

Begin
  Victoire := false;
  rangee[1] := 30;
  rangee[2] := 20;
  rangee[3] := 10;
  rangee[4] := 0;
  rangee[5] := 50;
  rangee[6] := 40;
  col := 0;
  point := 0;
  For i:= 1 to 6 do
    If (cor[i] = joueur) then
    Begin
      col := col+1;
      For j :=  1 to 10 do
        If (cases[rangee[i]+j].pion = i) then
          point := point+1;
    End;
  If (point = 10*col) then
  Begin
    present[joueur] := false;
    If (premier = 0) then
      premier := joueur;
  End;
  col := 0;
  For i:= 1 to 6 do
    If (present[i] = true) then
      col := col+1;
  If (col = 1) then
    Victoire := true;
End;
function exposant (entree : integer) : real;
Begin
  if entree = 0 then exposant := 1
  else exposant := 10 * exposant (entree - 1);
End;

Function calcultps : integer;
Var
  i : integer;
  chiffre : boolean;
  total : integer;
  tmpchain : string;

Begin
  chiffre := true;
  total := 0;
  tmpchain := ParamStr (1);
  for i := 1 to length (tmpchain) do
  begin
    if (tmpchain [i] < '0') or (tmpchain[i] > '9') then
      chiffre := false
    else
      total := total + (ord (tmpchain[i]) - 48)  * round ( exposant (length (tmpchain) - i));
  end;
  if (chiffre = false) or (total <= 0) then calcultps := 500
  else calcultps := total;
End;

Begin
  nbparam := ParamCount;
  if nbparam = 0 then tps := 500
  else tps := calcultps;
  init;
  Repeat
  ClearDevice;
  menu;
  correct := false;
  For i:= 1 to 6 do
    nom[i] := '??';
  init_mouse;
  affiche_mouse;
  i := 1;
  Repeat
    Repeat
      etat_mouse;
    Until (bouton = 1) and (position_x >= 5) and (position_x <= 135);
    if (position_y <= 17) and (position_y >= 5 ) then
    begin
              SetColor (0);
              Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
              nomf := 'damess2.ind';
              correct := true;
              nouv := true;
    end;
    if (position_y <= 47) and (position_y >= 35 ) then
    begin
               SetColor (0);
               Line (5,35,5,47);  Line (6,35,6,47);  Line (5,35,135,35);
               typ := true;
               cache_mouse;
               Demande (nomf,typ,echec);
               If (not (echec)) then
               Begin
                 correct := true;
                 nouv := false;
               End;
               cache_mouse;
               SetColor (15);
               Line (5,35,5,47);  Line (6,35,6,47);  Line (5,35,135,35);
               SetFillPattern(Gray50, 0);
               Bar(180, 150, 450, 370);
               affiche_mouse;
    end;
    if (position_y <= 77) and (position_y >= 65 ) then
    begin
               SetColor (0);
               Line (5,65,5,77);  Line (6,65,6,77);  Line (5,65,135,65);
               Vincent;
               SetColor (15);
               Line (5,65,5,77);  Line (6,65,6,77);  Line (5,65,135,65);
               SetFillPattern(Gray50, 0);
               Bar(180, 150, 450, 370);
               affiche_mouse;
    end;
    if (position_y <= 92) and (position_y >= 80 ) then
    begin
               closegraph;
               Halt (1);
    end;
  Until (correct);
  ancienne := -1;
  cache_mouse;
  Size := ImageSize(0, 0, 155, 105);
  GetMem(P, Size);   { Allocate memory on heap }
  GetImage(0, 0, 155, 105, P^);
  grille (cases,nomf,joueur,cle,nb,present,premier,cor,nouv,nom);
  PutImage(0, 0, P^, NormalPut);
  FreeMem (P,Size);
  prec := joueur;
  fin := false;
  SetColor (5);
  Affichage (cases);
  SetColor (15);
  Line (5,5,5,17);   Line (6,5,6,17);  Line (5,5,135,5);
  Repeat
    SetColor (0);
    OutTextXY (400,25,nom[prec]);
    SetColor (15);
    OutTextXY (400,25,nom[joueur]);
    affiche_mouse;
    If (cle=1) then
      deplacement (cases,active,joueur,prec,cle,sauve,P,size,ancienne,cor,nb,premier,nom);
    If (cle <>0) then
      deplacement (cases,active,joueur,prec,cle,sauve,P,size,ancienne,cor,nb,premier,nom);
    If (cle = 0) then
    Begin
      prec := joueur;
      fin := Victoire (cases,cor,present,joueur,premier);
      Repeat
        joueur := (joueur mod nb)+1;
      Until ((present[joueur] = true) or fin);
      cle := 1;
    End;
  Until fin;
  SetColor (15);
  OutTextXY (400,50,'Victoire de ' +  nom[premier]);
  Repeat
  Until KeyPressed;
  Readkey;
  Randomize;
  repeat
    SetColor (Random(16));
    Line(Random(650), Random(470), Random(GetMaxX), Random(GetMaxY));
  until KeyPressed;
  Readkey;
  Clrscr;
Until (0<>0);

End.